package edu.iastate.cs228.hw1;

import java.util.Arrays;

public class Battlefield<T extends MilitaryTransport> {
	private T[] arrayOfMilitaryTransports;
	private int currentSize;

	public Battlefield(int capacity) throws BattlefieldException {
		if (capacity <= 0) {
			throw new BattlefieldException("Capacity should be greater than 0");
		} else {
			arrayOfMilitaryTransports = (T[]) new MilitaryTransport[capacity];
			currentSize = 0;
		}
	}

	public MilitaryTransport[] getTransports() {
		return arrayOfMilitaryTransports;
	}

	public int getCapacity() {
		return arrayOfMilitaryTransports.length;
	}

	public void add(T transport) throws BattlefieldException {
		if (BattlefieldClient.duplicateName(this, transport)) {
			throw new BattlefieldException("Name is duplicated");
		}

		arrayOfMilitaryTransports[currentSize++] = transport;
	}

	public void remove(String transportName) throws BattlefieldException {
		if (currentSize == 0) {
			return;
		} else {

			if (!findName(transportName)) {
				throw new BattlefieldException("The name does not exist");
			}
			for (int i = 0; i < arrayOfMilitaryTransports.length; i++) {
				if (arrayOfMilitaryTransports[i].getName()
						.equals(transportName)) {
					arrayOfMilitaryTransports[i] = arrayOfMilitaryTransports[currentSize - 1];
					currentSize--;
				}
			}
		}

	}

	private boolean findName(String transportName) {
		for (MilitaryTransport e : arrayOfMilitaryTransports) {
			if (e.getName().equals(transportName)) {
				return true;
			}
		}

		return false;
	}

	public void simulate() throws BattlefieldException {
		int index = 0;
		while (index < currentSize) {
			for (int i = 0; i < currentSize; i++) {
				if (i != index) {
					arrayOfMilitaryTransports[index]
							.interact(arrayOfMilitaryTransports[i]);
				}
			}
			index ++;
		}
		
		for (int i = 0; i < currentSize; i++) {
			if (arrayOfMilitaryTransports[i].getDefense() <= 0) {
				this.remove(arrayOfMilitaryTransports[i].getName());
			}
		}
	}

	public String[] listTransportsSorted() {
		String[] allTransportString = new String[currentSize];
		T[] tempArray = (T[]) new MilitaryTransport[currentSize];
		
		for (int i = 0; i < currentSize; i++) {
			tempArray[i] = arrayOfMilitaryTransports[i];
		}
		
		Arrays.sort(tempArray);
		
		for (int i = 0; i < currentSize; i++) {
			allTransportString[i] = tempArray[i].toString();
		}
		return allTransportString;
	}

}
