package edu.iastate.cs228.hw1;
import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertFalse;
import static org.junit.Assert.assertNull;
import static org.junit.Assert.assertTrue;

import org.junit.Before;
import org.junit.Test;

public class BattlefieldTest {
	Battlefield<MilitaryTransport> mt;
	
	@Before
	public void setup() throws BattlefieldException{
		Battlefield<MilitaryTransport> mt = new Battlefield<MilitaryTransport>(10);
	}
	
	@Test(expected= BattlefieldException.class)
	public void testVoidCapacity() throws BattlefieldException{
		Battlefield<MilitaryTransport> b = new Battlefield<MilitaryTransport>(0);
	}
	
	@Test
	public void testGetCapacity() throws BattlefieldException{
		Battlefield<MilitaryTransport> b = new Battlefield<MilitaryTransport>(5);
		String msg = "Battlefield<T> constructed with capacity 5 should return 5 when calling getCapacity";
		assertEquals(msg, 5, b.getCapacity());
	}
	
	@Test
	public void testTankInAVBattlefield() throws BattlefieldException{
		Battlefield<ArmoredVehicle> b = new Battlefield<ArmoredVehicle>(2);
		Tank tank = new Tank("testTank", 80);
		b.add(tank);
		String msg = "Empty Battlefield<ArmoredVehicle> after adding Tank(\"testTank\", 80) will return it in its first cell";
		assertEquals(msg, tank, b.getTransports()[0]);
	}
	
	@Test
	public void testTankJeepBattlefield() throws BattlefieldException{
		Battlefield<MilitaryTransport> b = new Battlefield<MilitaryTransport>(2);
		Tank tank = new Tank("testTank", 80);
		Jeep jeep = new Jeep("testJeep", 80);
		b.add(tank);
		b.add(jeep);
		String msg = "Empty Battlefield<ArmoredVehicle> after adding Tank(\"testTank\", 80) and Jeep(\"testJeep\", 80) will return them in its first two cells";
		assertEquals(msg, tank, b.getTransports()[0]);
		assertEquals(msg, jeep, b.getTransports()[1]);
	}
	
	@Test (expected= BattlefieldException.class)
	public void testRemoveName() throws BattlefieldException{
		Tank tank = new Tank("testTank", 80);
		Jeep jeep = new Jeep("testJeep", 80);
		mt.add(tank);
		mt.add(jeep);
		mt.remove("test");
	}
	
	@Test (expected= BattlefieldException.class)
	public void testAddDulicatedName() throws BattlefieldException{
		Tank tank = new Tank("testTank", 80);
		Jeep jeep = new Jeep("testJeep", 80);
		mt.add(tank);
		mt.add(jeep);
		Tank tank2 = new Tank("testTank", 80);
		mt.add(tank2);
	}
	
	@Test 
	public void testSimulation() throws BattlefieldException{
		ArmoredVehicle armvh = new ArmoredVehicle("testArmV", 10);
		Tank tank = new Tank("testTank", 5);
		Jeep jeep = new Jeep("testJeep", 20);
		mt.add(armvh);
		mt.add(tank);
		mt.add(jeep);
		mt.simulate();
		assertEquals("After one round, the defense of ArmoredVehicle(\"testArmV\", 10) is 14.5", 29, armvh.getDefense());
		assertEquals("After one round, the defense of Tank(\"testTank\", 5) is 4", 4,tank.getDefense());
		assertEquals("After one round, the defense of Jeep(\"testTank\", 20) is 0", 0,jeep.getDefense());
	}
}
